diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index 1d53b34c9..58317c50e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -4,11 +4,11 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
 import org.lwjgl.opengl.GL11;
-public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFishingBobber>
-{
+
+public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFishingBobber> {
 
     public EntityRendererFishingBobber() {
         super(TextureRegistry.getTexture("minecraft:particle/bobber"));
@@ -17,21 +17,19 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
     @Override
     public void render(@NotNull Tessellator tessellator, @NotNull EntityFishingBobber entity, double x, double y, double z, float yaw, float partialTick) {
         super.render(tessellator, entity, x, y, z, yaw, partialTick);
-        if(entity.owner != null)
-        {
+        if (entity.owner != null) {
             int handedNess = entity.owner.isLeftHanded() ? -1 : 1;
             float f11 = entity.owner.getSwingProgress(partialTick);
             float f12 = MathHelper.sin(MathHelper.sqrt_float(f11) * MathHelper.PI);
-            Vec3 vec3 = Vec3.fromPool(-0.75D * handedNess, -0.05D, 0.8D);
-            vec3.rotateAroundX((-(entity.owner.xRotO + (entity.owner.xRot - entity.owner.xRotO) * partialTick) * MathHelper.PI) / 180F);
-            vec3.rotateAroundY((-(entity.owner.yRotO + (entity.owner.yRot - entity.owner.yRotO) * partialTick) * MathHelper.PI) / 180F);
-            vec3.rotateAroundY(f12 * 0.5F);
-            vec3.rotateAroundX(-f12 * 0.7F);
+            Vector3d vec3 = new Vector3d(-0.75D * handedNess, -0.05D, 0.8D);
+            vec3.rotateX((-(entity.owner.xRotO + (entity.owner.xRot - entity.owner.xRotO) * partialTick) * MathHelper.PI) / 180F);
+            vec3.rotateY((-(entity.owner.yRotO + (entity.owner.yRot - entity.owner.yRotO) * partialTick) * MathHelper.PI) / 180F);
+            vec3.rotateY(f12 * 0.5F);
+            vec3.rotateX(-f12 * 0.7F);
             double xp = MathHelper.lerp(entity.owner.xo, entity.owner.x, partialTick) + vec3.x;
             double yp = MathHelper.lerp(entity.owner.yo, entity.owner.y, partialTick) + entity.owner.getHeadHeight() + vec3.y;
             double zp = MathHelper.lerp(entity.owner.zo, entity.owner.z, partialTick) + vec3.z;
-            if(renderDispatcher.settings.thirdPersonView.value > 0)
-            {
+            if (this.renderDispatcher.settings.thirdPersonView.value > 0) {
                 float rr = ((entity.owner.yBodyRotO + (entity.owner.yBodyRot - entity.owner.yBodyRotO) * partialTick) * MathHelper.PI) / 180F;
                 double ss = MathHelper.sin(rr);
                 double cc = MathHelper.cos(rr);
@@ -39,20 +37,19 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
                 yp = MathHelper.lerp(entity.owner.yo, entity.owner.y, partialTick) + entity.owner.getHeadHeight() - 0.45D;
                 zp = (MathHelper.lerp(entity.owner.zo, entity.owner.z, partialTick) - (ss * 0.35D * handedNess)) + (cc * 0.85D);
             }
-            double xh = entity.xo + (entity.x - entity.xo) * (double)partialTick;
-            double yh = entity.yo + (entity.y - entity.yo) * (double)partialTick + 0.25D;
-            double zh = entity.zo + (entity.z - entity.zo) * (double)partialTick;
-            double xa = (float)(xp - xh);
-            double ya = (float)(yp - yh);
-            double za = (float)(zp - zh);
+            double xh = entity.xo + (entity.x - entity.xo) * (double) partialTick;
+            double yh = entity.yo + (entity.y - entity.yo) * (double) partialTick + 0.25D;
+            double zh = entity.zo + (entity.z - entity.zo) * (double) partialTick;
+            double xa = (float) (xp - xh);
+            double ya = (float) (yp - yh);
+            double za = (float) (zp - zh);
             GL11.glDisable(GL11.GL_TEXTURE_2D);
             GL11.glDisable(GL11.GL_LIGHTING);
             tessellator.startDrawing(3);
             tessellator.setColorOpaque_I(0);
-            for(int i = 0, steps = 16; i <= steps; i++)
-            {
-                final float aa = (float)i / (float)steps;
-                tessellator.addVertex(x + xa * (double)aa, y + ya * (double)(aa * aa + aa) * 0.5D + 0.25D, z + za * (double)aa);
+            for (int i = 0, steps = 16; i <= steps; i++) {
+                final float aa = (float) i / (float) steps;
+                tessellator.addVertex(x + xa * (double) aa, y + ya * (double) (aa * aa + aa) * 0.5D + 0.25D, z + za * (double) aa);
             }
 
             tessellator.draw();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index ff442e8b1..639b54edf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -9,8 +9,9 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
@@ -27,7 +28,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         final double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
         final double lerpY = MathHelper.lerp(minecart.yo, minecart.y, partialTick);
         final double lerpZ = MathHelper.lerp(minecart.zo, minecart.z, partialTick);
-        final Vec3 vec3 = minecart.getPos(lerpX, lerpY, lerpZ); // Opposite of velocity vector?
+        final Vector3dc pos = minecart.getPos(lerpX, lerpY, lerpZ); // Opposite of velocity vector?
         double lerpXRot = MathHelper.lerp(minecart.xRotO, minecart.xRot, partialTick);
 
         double renderX = x;
@@ -35,34 +36,34 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         double renderZ = z;
         double renderYaw = yaw;
         boolean doAFlip = false;
-        if(vec3 != null) {
+        if (pos != null) {
 //            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.5, z), Vec3.fromPool(-(vec3.x - lerpX), -(vec3.y - lerpY), -(vec3.z - lerpZ)), 1.5, 1, 0, 0, 1);
             final double scalar = 0.3D;
-            Vec3 forVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, scalar);
-            Vec3 backVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, -scalar);
-            if(forVec == null) {
-                forVec = vec3;
+            Vector3dc forVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, scalar);
+            Vector3dc backVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, -scalar);
+            if (forVec == null) {
+                forVec = pos;
             }
-            if(backVec == null) {
-                backVec = vec3;
+            if (backVec == null) {
+                backVec = pos;
             }
 
 //            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.6, z), Vec3.fromPool(forVec.x - lerpX, forVec.y - lerpY, forVec.z - lerpZ), 1.5, 0, 1, 0, 1);
 //            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.7, z), Vec3.fromPool(backVec.x - lerpX, backVec.y - lerpY, backVec.z - lerpZ), 1.5, 0, 0, 1, 1);
 
-            renderX += vec3.x - lerpX;
-            renderY += (forVec.y + backVec.y) / 2D - lerpY;
-            renderZ += vec3.z - lerpZ;
-            Vec3 velVec = backVec.add(-forVec.x, -forVec.y, -forVec.z);
-            if(velVec.length() != 0.0D) {
-                velVec = velVec.normalize();
+            renderX += pos.x() - lerpX;
+            renderY += (forVec.y() + backVec.y()) / 2D - lerpY;
+            renderZ += pos.z() - lerpZ;
+            Vector3d velVec = backVec.add(-forVec.x(), -forVec.y(), -forVec.z(), new Vector3d());
+            if (velVec.length() != 0.0D) {
+                velVec.normalize();
                 renderYaw = Math.toDegrees(Math.atan2(velVec.z, velVec.x));
                 lerpXRot = Math.atan(velVec.y) * 73D;
             }
 
-            final Vec3 realVecVec = Vec3.fromPool(minecart.xd, minecart.yd, minecart.zd);
+            final Vector3dc realVecVec = new Vector3d(minecart.xd, minecart.yd, minecart.zd);
 
-            doAFlip = velVec.dotProduct(realVecVec) < 0;
+            doAFlip = velVec.dot(realVecVec) < 0;
 
 //            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.8, z), Vec3.fromPool(velVec.x, velVec.y, velVec.z), 1.5, 0, 1, 1, 1);
         }
@@ -71,31 +72,31 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         GL11.glRotated(-lerpXRot, 0.0F, 0.0F, 1.0F);
         final double hurtAngle = minecart.timeSinceHit - partialTick;
         double currentDamage = minecart.currentDamage - partialTick;
-        if(currentDamage < 0.0F) {
+        if (currentDamage < 0.0F) {
             currentDamage = 0.0F;
         }
-        if(hurtAngle > 0.0F) {
-            GL11.glRotated(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float)minecart.hurtDirection, 1.0F, 0.0F, 0.0F);
+        if (hurtAngle > 0.0F) {
+            GL11.glRotated(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float) minecart.hurtDirection, 1.0F, 0.0F, 0.0F);
         }
         // Render block in cart
-        if(minecart.getType() != EntityMinecart.PASSENGER_CART) {
+        if (minecart.getType() != EntityMinecart.PASSENGER_CART) {
             TextureRegistry.blockAtlas.bind();
             final float scale = 0.75F;
             GL11.glScalef(scale, scale, scale);
             GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
             GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
             float brightness = 1.0f;
-            if(LightmapHelper.isLightmapEnabled()) {
+            if (LightmapHelper.isLightmapEnabled()) {
                 LightmapHelper.setLightmapCoord(minecart.getLightmap(partialTick));
-            } else if(!Global.accessor.isFullbrightEnabled()) {
+            } else if (!Global.accessor.isFullbrightEnabled()) {
                 brightness = minecart.getBrightness(partialTick);
             }
 
             GL11.glPushMatrix();
-            if (doAFlip){
+            if (doAFlip) {
                 GL11.glRotatef(180, 0, 1, 0);
             }
-            switch (minecart.getType()){
+            switch (minecart.getType()) {
                 case EntityMinecart.CHEST_CART:
                     final Block<?> block;
                     if ((minecart.getMeta() & 0b0000_0001) != 0) {
@@ -119,23 +120,23 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
             GL11.glScalef(1.0F / scale, 1.0F / scale, 1.0F / scale);
         }
         bindTexture("/assets/minecraft/textures/entity/cart.png");
-        GL11.glScalef(1/16f, 1/16f, -1/16f);
+        GL11.glScalef(1 / 16f, 1 / 16f, -1 / 16f);
         getModel("main").render(tessellator);
         GL11.glPopMatrix();
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
-    private static void drawDebugVec(final Tessellator tessellator, final Vec3 pos, final Vec3 vec, final double scale, final float r, final float g, final float b, final float a){
-        if (pos == null || vec == null) return;
+
+    private static void drawDebugVec(final @NotNull Tessellator tessellator, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final double scale, final float r, final float g, final float b, final float a) {
         GL11.glLineWidth(10);
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_TEXTURE_2D);
         tessellator.startDrawing(GL11.GL_LINES);
         tessellator.setColorRGBA_F(r, g, b, a);
-        tessellator.addVertex(pos.x, pos.y, pos.z);
+        tessellator.addVertex(start.x(), start.y(), start.z());
         tessellator.addVertex(
-            pos.x + vec.x * scale,
-            pos.y + vec.y * scale,
-            pos.z + vec.z * scale);
+            start.x() + end.x() * scale,
+            start.y() + end.y() * scale,
+            start.z() + end.z() * scale);
         tessellator.draw();
         GL11.glEnable(GL11.GL_TEXTURE_2D);
         GL11.glEnable(GL11.GL_LIGHTING);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 92294f5df..7b1d79f9c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -10,9 +10,9 @@ import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.slf4j.Logger;
@@ -247,7 +247,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
     }
 
     @Override
-    public @NotNull AABB entityViewBox(@NotNull final T entity) {
+    public @NotNull AABBdc entityViewBox(@NotNull final T entity) {
 //        return this.entityModel.visibleBounds().cloneMove(entity.x, entity.y, entity.z);
         return super.entityViewBox(entity);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index bb8fe099c..d8640e467 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -19,6 +19,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.BlocksContainer;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -72,8 +73,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
     }
 
     public void drawHeldObject(final Player player, final float partialTick) {
-        if (player.getHeldObject() instanceof CarriedBlock) {
-            final CarriedBlock carriedBlock = (CarriedBlock)player.getHeldObject();
+        if (player.getHeldObject() instanceof CarriedBlock carriedBlock) {
             if (this.container == null || this.container.world != player.world) {
                 this.container = new BlocksContainer(player.world);
             }
@@ -95,16 +95,14 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
             GL11.glScalef(0.55f, -0.55f, 0.55f);
             GL11.glTranslatef(0, -0.75f, -0.75f);
 
-            final int blockX = MathHelper.floor(player.x);
-            final int blockY = MathHelper.floor(player.y) + 1;
-            final int blockZ = MathHelper.floor(player.z);
+            final TilePos blockPos = new TilePos(player.x, player.y + 1, player.z);
 
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
+            tessellator.setTranslation(-blockPos.x -0.5, -blockPos.y -0.5, -blockPos.z -0.5);
 
             this.container.setLightReferenceEntity(player);
-            this.container.setBlock(blockX, blockY, blockZ, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
-            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, this.container, blockX, blockY, blockZ);
+            this.container.setBlock(blockPos.x, blockPos.y, blockPos.z, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, this.container, blockPos);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
             this.container.setLightReferenceEntity(null);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index d83c56ca8..f8fb8869f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -11,16 +11,16 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Random;
 import org.joml.Vector2d;
+import org.joml.Vector3d;
 import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.joml.primitives.Rayd;
 
 import java.util.List;
@@ -153,7 +153,7 @@ public class Particle {
             switch (hitTile.side) {
                 case EAST:
                 case WEST: {
-                    this.x = hitTile.location.x += hitTile.side.getOffsetX() * 0.01d * this.size;
+                    this.x = hitTile.location.x() + hitTile.side.getOffsetX() * 0.01d * this.size;
                     this.y += yd;
                     this.z += zd;
                     this.xd = 0;
@@ -163,7 +163,7 @@ public class Particle {
                     this.onGround = true;
                 case BOTTOM: {
                     this.x += xd;
-                    this.y = hitTile.location.y += hitTile.side.getOffsetY() * 0.01d * this.size;
+                    this.y = hitTile.location.y() + hitTile.side.getOffsetY() * 0.01d * this.size;
                     this.z += zd;
                     this.yd = 0;
                     break;
@@ -172,7 +172,7 @@ public class Particle {
                 case NORTH: {
                     this.x += xd;
                     this.y += yd;
-                    this.z = hitTile.location.z += hitTile.side.getOffsetZ() * 0.01d * this.size;
+                    this.z = hitTile.location.z() + hitTile.side.getOffsetZ() * 0.01d * this.size;
                     this.zd = 0;
                     break;
                 }
@@ -184,11 +184,11 @@ public class Particle {
         }
     }
 
-    private final AABBd __singleAABB = new AABBd();
     private final Vector2d __r = new Vector2d();
     private final Rayd __ray = new Rayd();
-    private final List<AABB> aabbs = new ObjectArrayList<>();
-    private final AABB refAABB = AABB.fromPool(0, 0, 0, 0, 0, 0);
+    private final List<AABBdc> aabbs = new ObjectArrayList<>();
+    private final AABBd refAABB = new AABBd();
+
     public @Nullable HitResult raycastBlocks(final double ox, final double oy, final double oz, final double xd, final double yd, final double zd) {
         this.__ray.oX = ox;
         this.__ray.oY = oy;
@@ -211,9 +211,9 @@ public class Particle {
 
         TilePos tilePos = new TilePos(ray.oX, ray.oY, ray.oZ);
 
-        double sideDistX = -(ray.oX - (tilePos.x + 0.5)) * (1/ray.dX) + 0.5 * dDistX;
-        double sideDistY = -(ray.oY - (tilePos.y + 0.5)) * (1/ray.dY) + 0.5 * dDistY;
-        double sideDistZ = -(ray.oZ - (tilePos.z + 0.5)) * (1/ray.dZ) + 0.5 * dDistZ;
+        double sideDistX = -(ray.oX - (tilePos.x + 0.5)) * (1 / ray.dX) + 0.5 * dDistX;
+        double sideDistY = -(ray.oY - (tilePos.y + 0.5)) * (1 / ray.dY) + 0.5 * dDistY;
+        double sideDistZ = -(ray.oZ - (tilePos.z + 0.5)) * (1 / ray.dZ) + 0.5 * dDistZ;
 
         double dx = 0.0;
         double dy = 0.0;
@@ -224,13 +224,10 @@ public class Particle {
             Block<?> block = this.world.getBlock(tilePos);
             if (block != null && collidesWithBlock(block, this.world.getBlockData(tilePos))) {
                 this.aabbs.clear();
-                block.getCollisionAABBs(this.world, tilePos, this.refAABB.set(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1, tilePos.y + 1, tilePos.z + 1), this.aabbs);
+                block.getCollisionAABBs(this.world, tilePos, this.refAABB.setMin(tilePos.x, tilePos.y, tilePos.z).setMax(tilePos.x + 1, tilePos.y + 1, tilePos.z + 1), this.aabbs);
                 double tMin = Double.MAX_VALUE;
                 for (int i = 0, aabbsSize = this.aabbs.size(); i < aabbsSize; i++) {
-                    AABB aabb = this.aabbs.get(i);
-                    this.__singleAABB.setMin(aabb.minX, aabb.minY, aabb.minZ);
-                    this.__singleAABB.setMax(aabb.maxX, aabb.maxY, aabb.maxZ);
-                    if (this.__singleAABB.intersectsRay(ray, this.__r)) {
+                    if (this.aabbs.get(i).intersectsRay(ray, this.__r)) {
                         tMin = org.joml.Math.min(this.__r.x, tMin);
                     }
                 }
@@ -238,7 +235,7 @@ public class Particle {
                     return new HitResult.Tile(
                         tilePos,
                         direction.getSide(),
-                        Vec3.fromPool(ray.oX + tMin * ray.dX, ray.oY + tMin * ray.dY, ray.oZ + tMin * ray.dZ));
+                        new Vector3d(ray.oX + tMin * ray.dX, ray.oY + tMin * ray.dY, ray.oZ + tMin * ray.dZ));
                 }
                 return null;
             }
@@ -247,7 +244,7 @@ public class Particle {
                 tilePos.x += signX;
                 dx = tilePos.x - ray.oX;
                 sideDistX += dDistX;
-                direction =  signX > 0 ? Direction.WEST : Direction.EAST;
+                direction = signX > 0 ? Direction.WEST : Direction.EAST;
             } else if (Double.isFinite(sideDistY) && sideDistY < sideDistZ) {
                 tilePos.y += signY;
                 dy = tilePos.y - ray.oY;
@@ -329,17 +326,13 @@ public class Particle {
         final int skylight;
         final int blocklight;
         if (this.world.getBlockLitInteriorSurface(blockPos)) {
-            TilePos tu = blockPos.up();
-            TilePos tw = blockPos.west();
-            TilePos te = blockPos.east();
-            TilePos ts = blockPos.south();
-            TilePos tn = blockPos.north();
-
-            int bU = this.world.getSavedLightValue(LightLayer.Block, tu);
-            final int bW = this.world.getSavedLightValue(LightLayer.Block, tw);
-            final int bE = this.world.getSavedLightValue(LightLayer.Block, te);
-            final int bS = this.world.getSavedLightValue(LightLayer.Block, ts);
-            final int bN = this.world.getSavedLightValue(LightLayer.Block, tn);
+            TilePos queryPos = new TilePos();
+
+            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
+            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
+            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
+            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
+            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
             if (bW > bU) {
                 bU = bW;
             }
@@ -354,11 +347,11 @@ public class Particle {
             }
             blocklight = bU;
 
-            int sU = this.world.getSavedLightValue(LightLayer.Sky, tu);
-            final int sW = this.world.getSavedLightValue(LightLayer.Sky, tw);
-            final int sE = this.world.getSavedLightValue(LightLayer.Sky, te);
-            final int sS = this.world.getSavedLightValue(LightLayer.Sky, ts);
-            final int sN = this.world.getSavedLightValue(LightLayer.Sky, tn);
+            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
+            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
+            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
+            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
+            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
             if (sW > sU) {
                 sU = sW;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index 9a3ea1042..889106529 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -11,6 +11,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 
 public class ParticleBlockBreaking extends Particle {
@@ -27,12 +28,12 @@ public class ParticleBlockBreaking extends Particle {
         this.size /= 2.0F;
     }
 
-    public ParticleBlockBreaking init(int x, int y, int z) {
-        int meta = this.world.getBlockMetadata(x, y, z);
+    public ParticleBlockBreaking init(@NotNull TilePos tilePos) {
+        int meta = this.world.getBlockData(tilePos);
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(this.block);
-        int index = model.particleColorIndex(this.world, x, y, z, this.side, meta);
+        int index = model.particleColorIndex(this.world, tilePos, this.side, meta);
         if (index >= 0) {
-            int col = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(this.world, x, y, z, index);
+            int col = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(this.world, tilePos, index);
             this.rCol *= (col >> 16 & 0xff) / 255F;
             this.gCol *= (col >> 8 & 0xff) / 255F;
             this.bCol *= (col & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
index 625ab1be2..705badb1e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 
@@ -36,7 +36,7 @@ public class ParticleBubble extends Particle {
         this.xd *= 0.85D;
         this.yd *= 0.85D;
         this.zd *= 0.85D;
-        if (this.needsWater && this.world.getBlockMaterial(new TilePos(this.x, this.y, this.z)) != Material.water) {
+        if (this.needsWater && this.world.getBlockMaterial(new TilePos(this.x, this.y, this.z)) != Materials.WATER) {
             remove();
         }
         if (this.lifetime-- <= 0) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index 60d84995a..beb82d684 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -50,7 +50,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init(new TilePos(x, y, z)));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ));
         addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleHeart(world, x, y, z, motionX, motionY, motionZ));
         addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index 749493bd0..e259f194f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -19,11 +19,13 @@ public class Shader {
     protected int vertexShader;
     protected int fragmentShader;
 
+    public boolean supported = true;
     protected boolean enabled = false;
 
     protected final Object2IntMap<String> uniformLocations = new Object2IntArrayMap<>();
 
     public @NotNull Shader compile(@NotNull ShaderProvider folder, @NotNull String name) {
+        if (!supported) return this;
         OpenGLHelper.checkError("pre compile shader " + name);
 
         delete();
